#!/usr/bin/perl
 
########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#### EDIT HERE -- FOR WINDOWS/IIS BASED INSTALLATIONS ONLY #######

$config_cgi = "../config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO config.cgi

# THE PATH ON A WINDOWS INSTALLATION WILL LOOK SOMETHING LIKE THIS:
# $config_cgi = "c:/inetpub/webpub/cgi-bin/pseek/config.cgi";

#### DO NOT CHANGE ANYTHING BELOW THIS LINE #################

$default_permissions = 0777; ### PERMISSIONS THAT IS USED FOR DATA FILES  

#use FindBin;
#use lib $FindBin::Bin;
use CGI;
use DBI;
use acs;
use Time::Local; 
use obbuild;

&get_setup;
$q = CGI->new;

acs::check_access($username, $password, $q->param('username'), $q->param('password'));

$default_permissions = 0777; ### PERMISSIONS THAT IS USED FOR TEMPORARY DATA FILES 

##################################################################################

print "Content-type: text/html\n\n";

$ldata = &get_file_contents("$data_dir/backup.cfg"); 
@allditems = split (/\n/, $ldata);
$mysqldump = $allditems[1];

if ((-e "$mysqldump") < 1)
	{
	acs::problem_popup("$mysqldump does not exist. The mysqldump program is used to create a backup. Rerun the backup configuration utility.");
	exit;
	}

unlink ("$data_dir/dbbackup/stderr.txt");

$cmd_line = "$mysqldump -u $db_username -p$db_password $db_name $remote_host_crit --quick --no-create-info --complete-insert --add-locks \> $data_dir/dbbackup/$db_name.sql";

system("$cmd_line 2>$data_dir/dbbackup/stderr.txt");

$lerrors = &get_file_contents("$data_dir/dbbackup/stderr.txt"); 

if ($lerrors ne "")
	{

$lerrors =~ s/\n/<BR>/gi;

print qq[
<html>
<head>
<title>PowerSeek</title>
</head>
<body>
<table border="0" cellpadding="6" cellspacing="1" width="100%">
  <tr>
    <td width="1%" valign="top"><p align="center"><img src="$web_url/add.gif"></td>
    <td width="95%" valign="top"><strong><font face="Arial" size="4">Backup not Completed</font><font
    face="Arial" size="4" color="#0000A0"><br>
    </font></strong><font face="Verdana" size="1"><b>The following errors occurred:</b><BR><BR>$lerrors</font></td>
  </tr>
</table>
<p>&nbsp;</p>
</body>
</html>
];

	}
else
	{


$file_size = (-s "$data_dir/dbbackup/$db_name.sql");	
	
	
print qq[
<html>
<head>
<title>PowerSeek</title>
</head>
<body>
<table border="0" cellpadding="6" cellspacing="1" width="100%">
  <tr>
    <td width="1%" valign="top"><p align="center"><img src="$web_url/add.gif"></td>
    <td width="95%" valign="top"><strong><font face="Arial" size="4">Backup Completed</font><font
    face="Arial" size="4" color="#0000A0"><br>
    </font></strong><font face="Verdana" size="1">File size of backup file: $data_dir/dbbackup/$db_name.sql = $file_size bytes
    <BR><BR>mysqldump command: $cmd_line</font></td>
  </tr>
</table>
<p>&nbsp;</p>
</body>
</html>	
];
	}
	



##################################################################################

sub get_setup
{

$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, "$config_cgi");
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
				$line =~ s/\n//g;
	
if ($line =~ /^DB_NAME/){$db_name = &get_setup_line($line, DB_NAME);}
if ($line =~ /^DB_USERNAME/){$db_username = &get_setup_line($line, DB_USERNAME);}
if ($line =~ /^DB_PASSWORD/){$db_password = &get_setup_line($line, DB_PASSWORD);}
if ($line =~ /^MYSQL_HOSTNAME/){$mysql_hostname = &get_setup_line($line, MYSQL_HOSTNAME);}
if ($line =~ /^MYSQL_PORT/){$mysql_port = &get_setup_line($line, MYSQL_PORT);}

if ($line =~ /^SCRIPT_URL/){$script_url = &get_setup_line($line, SCRIPT_URL);}
if ($line =~ /^ADMIN_URL/){$admin_url = &get_setup_line($line, ADMIN_URL);}
if ($line =~ /^WEB_URL/){$web_url = &get_setup_line($line, WEB_URL);}
if ($line =~ /^WEB_DIR/){$web_dir = &get_setup_line($line, WEB_DIR);}
if ($line =~ /^DATA_DIR/){$data_dir = &get_setup_line($line, DATA_DIR);}

if ($line =~ /^USERNAME/){$username = &get_setup_line($line, USERNAME);}
if ($line =~ /^PASSWORD/){$password = &get_setup_line($line, PASSWORD);}


			}
	close (STP);
	
	}
}




sub get_setup_line
{
my ($setup_line, $setup_var) = @_;
$crit = "\"";
$setup_line =~ m/$crit/g;
$r1 = pos($setup_line);
$setup_line =~ m/$crit/g;
$r2 = pos($setup_line);
$setup_line = substr($setup_line, $r1, ($r2 - $r1 - 1));
$return_val = $setup_line;
return ($return_val);
}

#### END CONFIGURATION ########################################################

